/*
 *
 * times.c: Function to time code
 * 	In a multiprocess-multiuser environment, it's difficult to find out
 *	how much time you spend in YOUR code. Unix supplies the times(2)
 *	system call, but it's hard to call from fortran, so we provide a 
 *	C-Stub here.
 * Author: Klaus Ramstoeck, 12/12/1992
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <sys/times.h>

long ticks = -1;

#ifdef STANDALONE
main(argc, argv) int argc; char *argv[];
{
	double timer();
	int i;

	printf("Time: %f\n", tim());
	for(i=0; i<10000000; i++);
	printf("Time: %f\n", tim());
}
#endif

double timer()
{
	struct tms tbuf;

	if(ticks<0) ticks=sysconf(_SC_CLK_TCK);
	times( &tbuf);
	return ((double)tbuf.tms_utime)/ticks;

}

/* Sun's postpend an underscore in fortran, so the linker looks for
 * _timer_ instead of _timer. We QuickFix by defining timer_
 */	
double timer_()
{
	struct tms tbuf;

	if(ticks<0) ticks=sysconf(_SC_CLK_TCK);
	times( &tbuf);
	return ((double)tbuf.tms_utime)/ticks;
}

/* 
 * Cray gimmick: Capitalize Fortran symbols...
 */	
double TIMER()
{
	struct tms tbuf;

	if(ticks<0) ticks=sysconf(_SC_CLK_TCK);
	times( &tbuf);
	return ((double)tbuf.tms_utime)/ticks;

	/* For Crays, you could also use this:
	 *
	 * return rtc()*6.6e-09
	 *
	 */

}
	
